/*
	MiniMemo v1.0
*/

#include 	<sys/bios.h>
#include	<stdio.h>
#include 	<fcntl.h>
#include	<stdlib.h>
#include	<string.h>

#include	"rome_tbl.h"

#define		KEY_B0	(0xB0)
#define		KEY_B1	(0xB1)
#define		KEY_B2	(0xB2)
#define		KEY_B3	(0xB3)
#define		KEY_B4	(0xB4)
#define		KEY_B5	(0xB5)
#define		KEY_B6	(0xB6)
#define		KEY_B7	(0xB7)
#define		KEY_B8	(0xB8)
#define		KEY_B9	(0xB9)
#define		KEY_BA	(0xBA)
#define		KEY_BB	(0xBB)
#define		KEY_BC	(0xBC)
#define		KEY_BD	(0xBD)
#define		KEY_BE	(0xBE)
#define		KEY_BF	(0xBF)

#define		KEY_0	(0)
#define		KEY_1	(1)
#define		KEY_2	(2)
#define		KEY_3	(3)
#define		KEY_4	(4)
#define		KEY_5	(5)
#define		KEY_6	(6)
#define		KEY_7	(7)
#define		KEY_8	(8)
#define		KEY_9	(9)
#define		KEY_10	(10)
#define		KEY_11	(11)
#define		KEY_12	(12)
#define		KEY_13	(13)
#define		KEY_14	(14)
#define		KEY_15	(15)

/*
p/J^Ji/Ђ炪
	[U  ][I  ][A  ][SP ]
	  4    3    2    0
	[E  ][KGC][SZF][TDJ]
	  5    7    8    9
	[O  ][NLQ][HPB][MV~]
	  6   10   11   12
	[BS ][YX-][R?!][W.,]
	  1   13   14   15


	[ 7 ][ 8 ][ 9 ][SP ]
	  4    3    2    0
	[ 4 ][ 5 ][ 6 ][ \ ]
	  5    7    8    9
	[ 1 ][ 2 ][ 3 ][ $ ]
	  6   10   11   12
	[BS ][ 0 ][ @ ][ # ]
	  1   13   14   15

L
	[=| ][^~ ]["' ][SP ]
	  4    3    2    0
	[+- ][* /][\$ ][@# ]
	  5    7    8    9
	[() ][[] ][{} ][<> ]
	  6   10   11   12
	[BS ][;: ][., ][!? ]
	  1   13   14   15

	Y1 - }/㏑[h؊
	Y2 - j[
	Y3 - ̓[h؊
	Y4 - DELETE

	X1 - J[\
	X2 - J[\
	X3 - J[\
	X4 - J[\
*/

extern	int		unfix_len;

/* ========================================================================= */

#define BUF_SIZE	256					/* VAʐMobt@TCY */

static char		recv_buf[BUF_SIZE];		/* Mobt@ */
static int		recv_s = 0;				/* Mobt@݈̏ʒu */
static int		recv_g = 0;				/* Mobt@̓ǂݏoʒu */
static int		recv_byte = 0;			/* MoCg */
static int		recv_err = 0;			/* MG[oCg */
static int		default_baud;			/* VXeʐMx */

/*
	VAM荞ݏ
*/
void far rx_interrupt(void)
{
	int		rc;

	switch((rc = comm_receive_char()))
	{
		case ERR_SIO_TIMEOUT:
			break;
		case ERR_SIO_CANCEL:
		case ERR_SIO_OVERRUN:
			recv_err++;
			break;
		default:
			if(recv_byte < BUF_SIZE)
			{
				recv_buf[recv_s++] = (char)rc;
				if(recv_s > BUF_SIZE) recv_s = 0;
				recv_byte++;
			}
	}
}

/*
	M
*/
int rx_len(void)
{
	return recv_byte;
}

/*
	Mobt@P擾
*/
int rx_getchar(void)
{
	int		c;

	if(recv_byte == 0) return -1;
	c = recv_buf[recv_g++];
	if(recv_g > BUF_SIZE) recv_g = 0;
	recv_byte--;
	return c;
}

/*
	VAʐMJn
*/
void comm_start(int baud)
{
	static intvector_t 	iv;

	recv_s = 0;
	recv_g = 0;
	recv_byte = 0;
	recv_err = 0;

	default_baud = comm_get_baudrate();
	comm_set_baudrate(baud);
	comm_open();
	comm_set_timeout(0,1);

	/*
		荞݃tbNݒ
	*/
	iv.callback = (void (near *)())FP_OFF(rx_interrupt);
	iv.cs =  _asm_inline("mov ax, cs");
	iv.ds =  _asm_inline("mov ax, ds");
	sys_interrupt_set_hook(SYS_INT_RECEIVEREADY, &iv, NULL);
}

/*
	VAʐMI
*/
void comm_stop()
{
	/*
		荞݃tbN
	*/
	sys_interrupt_reset_hook(SYS_INT_RECEIVEREADY, NULL);

	comm_close();
	comm_set_baudrate(default_baud);
}

/* ========================================================================= */

static int	page_buf[10][17][28];	/* y[Wobt@ */
static int	copy_buf[28];
static BOOL	in_copy = FALSE;

/*
	t@Cǂݍ
*/
BOOL read_memo()
{
	static char	fname[30];
	int			fd;

	/*
		y[Wobt@NA
	*/
	memset(page_buf, 0, sizeof(page_buf));

	/*
		t@CǂݍށB
	*/
	strcpy(fname, "/ram0/mmemo.dat");
	if((fd = open(fname, O_RDONLY, 0)) < 0)
	{
		if(creat(fname, FMODE_R|FMODE_W, sizeof(page_buf) / 128 + 1)
			== E_FS_SUCCESS)
		{
			fs_setinfo(fname, "~jf[^");
			return TRUE;
		}
		return FALSE;
	}
	else
	{
		if(read(fd, (char *)page_buf, sizeof(page_buf)) < 0)
		{
			close(fd);
			return FALSE;
		}
		close(fd);
    }

	return TRUE;
}

/*
	t@Co
*/
BOOL write_memo()
{
	static char	fname[30];
	int			fd;

	strcpy(fname, "/ram0/mmemo.dat");
	if((fd = open(fname, O_WRONLY, 0)) >= 0)
	{
		if(write(fd, (char *)page_buf, sizeof(page_buf)) < 0)
		{
			close(fd);
			return FALSE;
		}
		close(fd);
		return TRUE;
	}
	return FALSE;
}

/* ========================================================================= */

#define		HIDE_TIME	50				/* J[\_ */
#define		SHOW_TIME	50				/* J[\Ŏ */

static char		line_buf[60];			/* sobt@ */
static int		cur_page;				/* \y[W */
static int		cur_x = 0;				/* J[\ʒu */
static int		cur_y = 0;
static BOOL		cur_show = TRUE;		/* J[\\ */
static BOOL		cur_hide = FALSE;		/* J[\\֎~ */
static int		cur_blink;				/* J[\_ŗpJE^ */

/*
	J[\\
*/
void cur_on()
{
	if(!cur_hide)
	{
		font_set_color(0x0c);	/* ] */
		text_put_char(cur_x, cur_y + 1, page_buf[cur_page][cur_y][cur_x]);
		font_set_color(0x03);	/* ʏ */
		cur_show = TRUE;
	}
}

/*
	J[\
*/
void cur_off()
{
	if(!cur_hide)
	{
		font_set_color(0x03);	/* ʏ */
		text_put_char(cur_x, cur_y + 1, page_buf[cur_page][cur_y][cur_x]);
		cur_show = FALSE;
	}
}

/*
	J[\\
*/
void show_cursor()
{
	cur_hide = FALSE;
	cur_on();
}

/*
	J[\\֎~
*/
void hide_cursor()
{
	cur_off();
	cur_hide = TRUE;
}

/*
	J[\ړ
*/
void move_cursor(int cx, int cy)
{
	if(!cur_hide)
	{
		text_put_char(cur_x, cur_y + 1, page_buf[cur_page][cur_y][cur_x]);
		font_set_color(0x0c);	/* ] */
		text_put_char(cx, cy + 1, page_buf[cur_page][cy][cx]);
		font_set_color(0x03);	/* ʏ */
	}
	cur_x = cx;
	cur_y = cy;
	cur_show = TRUE;
	cur_blink = SHOW_TIME;
}

/*
	J[\_
*/
void blink_cursor()
{
	if(!cur_hide)
	{
		if(--cur_blink <= 0)
		{
			if(cur_show)
			{
				cur_off();
				cur_blink = HIDE_TIME;
			}
			else
			{
				cur_on();
				cur_blink = SHOW_TIME;
			}
		}
	}
}

/*
	J[\
*/
void cur_up()
{
	if(cur_y > 0) move_cursor(cur_x, cur_y - 1);
}

/*
	J[\
*/
void cur_right()
{
	if(cur_x < 27)
	{
		move_cursor(cur_x + 1, cur_y);
	}
	else
	{
		if(cur_y < 16) move_cursor(0, cur_y + 1);
	}
}

/*
	J[\
*/
void cur_down()
{
	if(cur_y < 16) move_cursor(cur_x, cur_y + 1);
}

/*
	J[\
*/
void cur_left()
{
	if(cur_x > 0)
	{
		move_cursor(cur_x - 1, cur_y);
	}
	else
	{
		if(cur_y > 0) move_cursor(27, cur_y - 1);
	}
}

/*
	y[W\
*/
void disp_page(int page_no)
{
	int				y, i, *pp;
	unsigned int	c;
	char			*lp;

	pp = (int *)page_buf[page_no];
	for(y = 0; y < 17; y++)
	{
		lp = line_buf;
		for(i = 0; i < 28; i++)
		{
			c = *pp++;
			if(c < 256)
			{
				if(c == 0) c = 0x20;
				*lp++ = (char)(c & 255);
			}
			else
			{
				*lp++ = (char)(c >> 8);
				*lp++ = (char)(c & 255);
			}
		}
		*lp = '\0';
		text_put_string(0, y + 1, line_buf);
	}
	cur_page = page_no;
	font_set_color(0x0c);	/* ] */
	text_put_numeric(26, 0, 2, NUM_PADZERO, cur_page + 1);	/* y[Wԍ */
	font_set_color(0x03);	/* ʏ */
	cur_on();
	cur_blink = SHOW_TIME;
}

/*
	wʒu̕\
*/
void disp_str(int x, int y, int len)
{
	int				i, *pp;
	unsigned int	c;
	char			*lp;

	pp = (int *)&page_buf[cur_page][y][x];
	lp = line_buf;
	for(i = 0; i < len; i++)
	{
		c = *pp++;
		if(c < 256)
		{
			if(c == 0) c = 0x20;
			*lp++ = (char)(c & 255);
		}
		else
		{
			*lp++ = (char)(c >> 8);
			*lp++ = (char)(c & 255);
		}
	}
	*lp = '\0';
	text_put_string(x, y + 1, line_buf);
}

/*
	w͈͂̕\
*/
void disp_area(int x, int y, int w, int h)
{
	int		i;

	for(i = 0; i < h; i++)
	{
		disp_str(x, y + i, w);
	}
}

/*
	J[\ʒuɕ}
*/
void insert_char(int c)
{
	int		w;

	w = 27 - cur_x;
	if(w > 0)
	{
		memcpy(line_buf, &page_buf[cur_page][cur_y][cur_x], w * 2);
		memcpy(&page_buf[cur_page][cur_y][cur_x + 1], line_buf, w * 2);
	}
	page_buf[cur_page][cur_y][cur_x] = c;
	disp_str(cur_x, cur_y, w + 1);
	cur_right();
}

/*
	J[\ʒuɕ㏑
*/
void overwrite_char(int c)
{
	page_buf[cur_page][cur_y][cur_x] = c;
	disp_str(cur_x, cur_y, 1);
	cur_right();
}

/*
	J[\ʒu̕폜
*/
void delete_char()
{
	int		w;

	w = 27 - cur_x;
	if(w > 0)
	{
		memcpy(line_buf, &page_buf[cur_page][cur_y][cur_x + 1], w * 2);
		memcpy(&page_buf[cur_page][cur_y][cur_x], line_buf, w * 2);
	}
	page_buf[cur_page][cur_y][27] = '\0';
	disp_str(cur_x, cur_y, w + 1);
	show_cursor();
}

/*
	obNXy[X
*/
void backspace()
{
	if(cur_x > 0)
	{
		cur_left();
		delete_char();
	}
}

/* ========================================================================= */

#define		MODE_UPPER	(0)		/* ASCII    [`] */
#define		MODE_LOWER	(1)		/* ASCII    [] */
#define		MODE_HIRA	(2)		/* Ђ炪 [] */
#define		MODE_KATA	(3)		/* J^Ji [A] */
#define		MODE_NUM	(4)		/*      [] */
#define		MODE_SYMBOL	(5)		/* L     [L] */

#define		INSERT		(0)		/* } */
#define		OVERWRITE	(1)		/* ㏑ */

#define		INSERT_POS	(15)	/* }/㏑CWP[^ʒu */
#define		MODE_POS	(18)	/* ̓[hCWP[^ʒu */

static char	*insert_disp[2] = { "}", "" };
static char	*mode_disp[6]   = { "`", "", "", "A", "", "L" };

static int	vowel_tbl[5] = {
				'A', 'I', 'U', 'E', 'O'
			};

static int	conso_tbl[9][3] = {
				'K', 'G', 'C', 'S', 'Z', 'F', 'T', 'D', 'J',
				'N', 'L', 'Q', 'H', 'B', 'P', 'M', 'V', '~',
				'Y', 'X', '-', 'R', '?', '!', 'W', '.', ','
			};

static int	num_tbl[16] = {
				' ', ' ', '9', '8', '7', '4', '1', '5',
				'6', '\\', '2', '3', '$', '0', '@', '#'
			};

static int	symbol_tbl[14][2] = {
				'"', 0x27,
				'^', '~',
				'=', '|',
				'+', '-',
				'(', ')',
				'*', '/',
				'\\', '$',
				'@', '#',
				'[', ']',
				'{', '}',
				'<', '>',
				';', ':',
				'.', ',',
				'!', '?'
			};

static int	input_mode = MODE_UPPER;		/* ̓[h */
static int	insert_mode = INSERT;			/* }/㏑[h */
static char	unfix_buf[20];					/* m蕶obt@ */
static int	unfix_len = 0;					/* m蕶 */
static int	unfix_prev = 0;					/* O̓̓L[ */
static int	unfix_shift = 0;				/* L[Vtg */

/*
	㏑[hύX
*/
void insert_change()
{
	insert_mode++;
	if(insert_mode > OVERWRITE)
	{
		insert_mode = INSERT;
	}
	font_set_color(0x0c);	/* ] */
	text_put_string(INSERT_POS, 0, insert_disp[insert_mode]);
	font_set_color(0x03);	/* ʏ */
}

/*
	̓[hύX
*/
void mode_change()
{
	input_mode++;
	if(input_mode > MODE_SYMBOL)
	{
		input_mode = MODE_UPPER;
	}
	font_set_color(0x0c);	/* ] */
	text_put_string(MODE_POS, 0, mode_disp[input_mode]);
	font_set_color(0x03);	/* ʏ */
}

/*
	ꕶ}
*/
void set_char(int c)
{
	if(insert_mode == INSERT)
	{
		insert_char(c);
	}
	else
	{
		overwrite_char(c);
	}
}

/*
	ȕ}
*/
void set_kanastring(char *s)
{
	int		i, len;
	int		c;

	if(input_mode == MODE_KATA)
	{
		if(strncmp(s, "J", 4) == 0)
		{
			set_char(0x8394);	/*  */
			s += 4;
		}
	}

	len = strlen(s) / 2;
	for(i = 0; i < len; i++)
	{
		c = (*s << 8)|(*(s + 1));
		if((input_mode == MODE_KATA)&&(c >= 0x829F))
		{
			if(c <= 0x82DD)
			{
				c += 0xA1;		/* Ђ炪->J^Ji(0x829F`0x82DD) */
			}
			else
			{
				c += 0xA2;		/* Ђ炪->J^Ji(0x82DE`0x82F1) */
			}
		}
		set_char(c);
		s += 2;
	}
}

/*
	mobt@sobt@
*/
void set_linebuf()
{
	memcpy(line_buf, unfix_buf, unfix_len);
	*(line_buf + unfix_len) = '\0';
}

/*
	mobt@\
*/
void disp_unfix()
{
	int		x;

	if(unfix_len > 0)
	{
		set_linebuf();
		x = (unfix_len + cur_x <= 28) ?
				cur_x : 28 - unfix_len;		/* ʒu␳ */
		font_set_color(0x0c);	/* ] */
		text_put_string(x, cur_y + 1, line_buf);
		font_set_color(0x03);	/* ʏ */
	}
}

/*
	mobt@B
*/
void hide_unfix()
{
	int		x;

	if(unfix_len > 0)
	{
		x = (cur_x + unfix_len <= 28) ?
				cur_x : 28 - unfix_len;	/* ʒu␳ */
		disp_str(x, cur_y, unfix_len);
	}
}

/*
	
*/
void clear_unfix()
{
	if(unfix_len > 0)
	{
		hide_unfix();
		unfix_len = 0;
		show_cursor();
	}
}

/*
	m
*/
void flash_unfix()
{
	int		i;

	if(unfix_len > 0)
	{
		hide_unfix();
		for(i = 0; i < unfix_len; i++)
		{
			set_char((int)unfix_buf[i]);
		}
		unfix_len = 0;
		show_cursor();
	}
}

/*
	L[R[h當R[hɕϊ
*/
char code_convert(int key, int shift)
{
	int		c;

	switch(input_mode)
	{
		case MODE_HIRA:
		case MODE_KATA:
		case MODE_UPPER:
			c = (key < KEY_7) ? vowel_tbl[key - KEY_2] :
			                    conso_tbl[key - KEY_7][shift];
			break;
		case MODE_LOWER:
			c = ((key < KEY_7) ? vowel_tbl[key - KEY_2] :
			                     conso_tbl[key - KEY_7][shift]) + 0x20;
			break;
		case MODE_NUM:
			c = num_tbl[key];
			break;
		case MODE_SYMBOL:
			c = symbol_tbl[key - KEY_2][shift];
			break;
	}
	return c;
}

/*
	m蕶obt@ɑ}
*/
void insert_unfix(int key)
{
	if(unfix_len > 0)
	{
		/*
			m蕶L
		*/
		if(unfix_prev == key)
		{
			/*
				m蕶ƓL[
			*/
			unfix_shift++;		/* \Vtg */
			if(unfix_shift > 2)
			{
				unfix_shift = 0;
			}
			unfix_buf[unfix_len - 1] = code_convert(key, unfix_shift);
			disp_unfix();
		}
		else
		{
			/*
				m蕶ƈقȂL[
			*/
			flash_unfix();
		}
	}
}

/*
	m蕶obt@ɍŏ̈ꕶi[
*/
void set_unfix(int key)
{
	unfix_buf[0] = code_convert(key, 0);
	unfix_prev = key;
	unfix_len = 1;
	unfix_shift = 0;
}

/*
	m蕶obt@̓eVtg
*/
void shift_unfix()
{
	int		i;

	for(i = 1; i < unfix_len; i++)
	{
		unfix_buf[i - 1] = unfix_buf[i];
	}
	unfix_len--;
}

/*
	m蕶obt@ɑ}(ASCII[h)
*/
void insert_ascii(int key)
{
	if((unfix_len > 0)&&(unfix_prev == key))
	{
		/*
			m蕶ƓL[Ȃ\Vtg
		*/
		unfix_shift++;
		if(unfix_shift > 2)
		{
			unfix_shift = 0;
		}
		unfix_buf[unfix_len - 1] = code_convert(key, unfix_shift);
		disp_unfix();
	}
	else
	{
		/*
			m蕶A܂͖m蕶ƈقȂL[
		*/
		if(unfix_len > 0)
		{
			/*
				m蕶LȂobt@e}
			*/
			flash_unfix();
		}

		if(key < KEY_7)
		{
			/*
				ꉹL[
			*/
			set_char(code_convert(key, 0));
		}
		else
		{
			/*
				m蕶obt@Ɋi[
			*/
			set_unfix(key);
			hide_cursor();
			disp_unfix();
		}
	}
}

/*
	[}e[u
*/
int kana_search(int no)
{
	struct ROME	*rp;
	int			i;

	rp = tbl_idx[no];
	for(i = 0; i < tbl_idx_size[no]; i++, rp++)
	{
		if(strcmp(line_buf, rp->r) == 0)
		{
			return i;
		}
	}

	return -1;
}

/*
	ȕϊ
*/
void kana_trans()
{
	struct ROME	*rp;
	int			top, no;

	/*
		m蕶
	*/
	hide_unfix();

	/*
		m蕶Ȃ邩AϊsɂȂ܂Ń[v
	*/
	while(unfix_len > 0)
	{
		top = (int)unfix_buf[0];	/* ŏ̈ꕶ */
		line_buf[0] = (char)(top & 255);
		line_buf[1] = '\0';
		/*
			ꕶe[u
		*/
		if((no = kana_search(0)) >= 0)
		{
			/*
				v
			*/
			rp = tbl_idx[0];
			set_kanastring((rp + no)->k);			/* ꕶm */
			/*
				ꕶVtg
			*/
			shift_unfix();
		}
		else
		{
			/*
				
			*/
			top -= 0x41;
			set_linebuf();
			if((no = kana_search(top)) >= 0)
			{
				/*
					m
				*/
				rp = tbl_idx[top];
				set_kanastring((rp + no)->k);
				unfix_len = 0;
			}
			else
			if((unfix_buf[0] == 'N')&&(unfix_len > 1))
			{
				/*
					'N' + q
				*/
				set_kanastring("");
				shift_unfix();
			}
			else
			if((unfix_buf[0] == unfix_buf[1])&&(unfix_len > 1))
			{
				/*
					q + q
				*/
				set_kanastring("");
				shift_unfix();
			}
			else
			{
				break;
			}
		}
	}

	/*
		m蕶ĕ\
	*/
	disp_unfix();
}

/*
	m蕶obt@ɑ}(ȃ[h)
*/
void insert_kana(int key)
{
	if((unfix_len > 0)&&(unfix_prev == key))
	{
		/*
			m蕶ƓL[Ȃ\Vtg
		*/
		unfix_shift++;
		if(unfix_shift > 2)
		{
			unfix_shift = 0;
		}
		unfix_buf[unfix_len - 1] = code_convert(key, unfix_shift);
		disp_unfix();
	}
	else
	{
		if(unfix_len == 0)
		{
			hide_cursor();
		}

		if(key < KEY_7)
		{
			/*
				ɖmobt@ɓĂ镶ϊ
			*/
			kana_trans();
			/*
				ꉹǉĕϊ
			*/
			unfix_buf[unfix_len++] = code_convert(key, 0);
			kana_trans();
			unfix_prev = 0;
			unfix_shift = 0;
		}
		else
		{
			/*
				ɖmobt@ɓĂ镶ϊ
			*/
			kana_trans();
			/*
				mobt@ɕǉĕ\
			*/
			unfix_buf[unfix_len++] = code_convert(key, 0);
			disp_unfix();
			unfix_prev = key;
			unfix_shift = 0;
		}

		if(unfix_len == 0)
		{
			show_cursor();
		}
	}
}

/*
	m蕶obt@ɑ}(L[h)
*/
void insert_symbol(int key)
{
	if((unfix_len > 0)&&(unfix_prev == key))
	{
		/*
			m蕶ƓL[Ȃ\Vtg
		*/
		unfix_shift++;
		if(unfix_shift > 1)
		{
			unfix_shift = 0;
		}
		unfix_buf[unfix_len - 1] = code_convert(key, unfix_shift);
		disp_unfix();
	}
	else
	{
		/*
			m蕶A܂͖m蕶ƈقȂL[
		*/
		if(unfix_len > 0)
		{
			/*
				m蕶LȂobt@e}
			*/
			flash_unfix();
		}

		/*
			m蕶obt@Ɋi[
		*/
		set_unfix(key);
		hide_cursor();
		disp_unfix();
	}
}

/*
	p[h
*/
void key_ascii(int key)
{
	switch(key)
	{
		case KEY_0:		/* m/SPACE */
			if(unfix_len > 0)
			{
				flash_unfix();
			}
			else
			{
				set_char(0x20);
			}
			break;
		case KEY_1:		/* /BACKSPACE */
			if(unfix_len > 0)
			{
				clear_unfix();
			}
			else
			{
				backspace();
			}
			break;
		default:		/* ̑̃L[ */
			insert_ascii(key);
	}
}

/*
	ȃ[h
*/
void key_kana(int key)
{
	switch(key)
	{
		case KEY_0:		/* m/SPACE */
			if(unfix_len > 0)
			{
				/*
					ɖmobt@ɓĂ镶ϊ
				*/
				kana_trans();
				unfix_prev = 0;
				unfix_shift = 0;
				if(unfix_len == 0)
				{
					show_cursor();
				}
			}
			else
			{
				set_char(0x20);
			}
			break;
		case KEY_1:		/* /BACKSPACE */
			if(unfix_len > 0)
			{
				clear_unfix();
			}
			else
			{
				backspace();
			}
			break;
		default:		/* ̑̃L[ */
			insert_kana(key);
	}
}

/*
	[h
*/
void key_numeric(int key)
{
	switch(key)
	{
		case KEY_0:		/* SPACE */
			set_char(0x20);
			break;
		case KEY_1:		/* BACKSPACE */
			backspace();
			break;
		default:		/* ̑̃L[ */
			set_char(code_convert(key, 0));
	}
}

/*
	L[h
*/
void key_symbol(int key)
{
	switch(key)
	{
		case KEY_0:		/* m/SPACE */
			if(unfix_len > 0)
			{
				flash_unfix();
			}
			else
			{
				set_char(0x20);
			}
			break;
		case KEY_1:		/* /BACKSPACE */
			if(unfix_len > 0)
			{
				clear_unfix();
			}
			else
			{
				backspace();
			}
			break;
		default:		/* ̑̃L[ */
			insert_symbol(key);
	}
}

/*
	gL[͏
*/
int ex_key_hit(int ex_key)
{
	static int	cc_tbl[16] = {
					 4,  3,  2,  0,
					 5,  7,  8,  9,
					 6, 10, 11, 12,
					 1, 13, 14, 15
				};

	ex_key = cc_tbl[ex_key - 0xB0];		/* L[R[hɕϊ */
	switch(input_mode)
	{
		case MODE_UPPER:
		case MODE_LOWER:
			key_ascii(ex_key);
			break;
		case MODE_HIRA:
		case MODE_KATA:
			key_kana(ex_key);
			break;
		case MODE_NUM:
			key_numeric(ex_key);
			break;
		case MODE_SYMBOL:
			key_symbol(ex_key);
			break;
	}
}

/* ========================================================================= */

/*
	y[W
*/
void page_clear()
{
	memset(&page_buf[cur_page], 0, sizeof(page_buf) / 10);
	disp_page(cur_page);
	cur_on();
	cur_blink = SHOW_TIME;
}

/*
	C
*/
void line_clear()
{
	memset(&page_buf[cur_page][cur_y], 0, 28 * 2);
	disp_str(0, cur_y, 28);
	cur_on();
	cur_blink = SHOW_TIME;
}

/*
	CRs[
*/
void line_copy()
{
	memcpy(copy_buf, &page_buf[cur_page][cur_y], 28 * 2);
	in_copy = TRUE;
}

/*
	Cy[Xg
*/
void line_paste()
{
	if(in_copy)
	{
		memcpy(&page_buf[cur_page][cur_y], copy_buf, 28 * 2);
		disp_str(0, cur_y, 28);
		cur_on();
		cur_blink = SHOW_TIME;
	}
}

/*
	C}
*/
void line_insert()
{
	int		i;

	for(i = 15; i >= cur_y; i--)
	{
		memcpy(&page_buf[cur_page][i + 1], &page_buf[cur_page][i], 28 * 2);
	}
	memset(&page_buf[cur_page][cur_y], 0, 28 * 2);
	disp_page(cur_page);
	cur_on();
	cur_blink = SHOW_TIME;
}

/*
	C폜
*/
void line_delete()
{
	if(cur_y < 16)
	{
		memcpy(&page_buf[cur_page][cur_y],
			   &page_buf[cur_page][cur_y + 1], 28 * 2 * (16 - cur_y));
	}
	memset(&page_buf[cur_page][16], 0, 28 * 2);
	disp_page(cur_page);
	cur_on();
	cur_blink = SHOW_TIME;
}

/* ========================================================================= */

#define		MENU_LINECOPY	(0)
#define		MENU_LINEPASTE	(1)
#define		MENU_LINECLR	(2)
#define		MENU_LINEINS	(3)
#define		MENU_LINEDEL	(4)
#define		MENU_PAGECLR	(5)

#define		EXIT_SAVE		(0)
#define		EXIT_NOSAVE		(1)

static char	*main_menu[] = {
				"s",
				"s\t",
				"s",
				"s}",
				"s폜",
				"ŏ"
			};

static char	*exit_menu[] = {
				"ۑďI",
				"jďI",
			};

static	int		menu_x, menu_y, menu_w, menu_n;
static	int		menu_c;
static	char	**menu_p;
static	char	menu_buf[40];

/*
	j[IJ[\\
*/
void show_select(int n)
{
	strcpy(menu_buf, " ");
	strcat(menu_buf, *(menu_p + n));
	strcat(menu_buf, " ");
	font_set_color(0x0c);	/* ] */
	text_put_string(menu_x + 1, menu_y + n + 2, menu_buf);
	font_set_color(0x03);	/* ʏ */
}

/*
	j[IJ[\
*/
void hide_select(int n)
{
	strcpy(menu_buf, " ");
	strcat(menu_buf, *(menu_p + n));
	strcat(menu_buf, " ");
	font_set_color(0x03);	/* ʏ */
	text_put_string(menu_x + 1, menu_y + n + 2, menu_buf);
}

/*
	j[\
*/
void show_menu(char **m, int x, int y, int w, int n)
{
	int		i;

	y++;
	strcpy(menu_buf, "");
	for(i = 0; i < w + 2; i++) strcat(menu_buf, "");
	strcat(menu_buf, "");
	text_put_string(x, y, menu_buf);
	for(i = 0; i < n; i++)
	{
		strcpy(menu_buf, " ");
		strcat(menu_buf, *(m + i));
		strcat(menu_buf, " ");
		text_put_string(x, y + i + 1, menu_buf);
	}
	strcpy(menu_buf, "");
	for(i = 0; i < w + 2; i++) strcat(menu_buf, "");
	strcat(menu_buf, "");
	text_put_string(x, y + n + 1, menu_buf);
}

/*
	j[
*/
void hide_menu(int x, int y, int w, int n)
{
	disp_area(x, y, w + 4, n + 2);
}

/*
	j[I
*/
int menu_select(char **m, int x, int y, int n)
{
	int		ws_key, ex_key;
	int		w, s, ret;
	BOOL	done = FALSE;

	menu_p = m;
	menu_x = x;
	menu_y = y;

	w = strlen(*m) / 2;
	show_menu(m, x, y, w, n);
	show_select(0);
	s = 0;
	while(!done)
	{
		/*
			X̃L[͏
		*/
		ws_key = key_hit_check_with_repeat();
		if(ws_key)
		{
			if(ws_key & KEY_A)
			{
				done = TRUE;
				ret = s;
				continue;
			}
			else
			if(ws_key & KEY_UP1)
			{
				if(s > 0)
				{
					hide_select(s--);
					show_select(s);
				}
				continue;
			}
			else
			if(ws_key & KEY_DOWN1)
			{
				if(s < n - 1)
				{
					hide_select(s++);
					show_select(s);
				}
				continue;
			}
			else
			if(ws_key & KEY_B)
			{
				done = TRUE;
				ret = -1;
				continue;
			}
		}

		/*
			HandyKeỹL[͏
		*/
		if(rx_len() > 0)
		{
			ex_key = rx_getchar();
			if(ex_key == KEY_B3)
			{
				done = TRUE;
				ret = s;
				continue;
			}
			else
			if(ex_key == KEY_BC)
			{
				done = TRUE;
				ret = -1;
				continue;
			}
		}
	}

	hide_menu(x, y, w, n);
	return ret;
}

void menu()
{
	int		sel;

	sel = menu_select(main_menu, 0, 0, sizeof(main_menu) / 2);
	switch(sel)
	{
		case -1:
			return;
		case MENU_PAGECLR:
			page_clear();
			break;
		case MENU_LINECLR:
			line_clear();
			break;
		case MENU_LINECOPY:
			line_copy();
			break;
		case MENU_LINEPASTE:
			line_paste();
			break;
		case MENU_LINEINS:
			line_insert();
			break;
		case MENU_LINEDEL:
			line_delete();
			break;
	}
}

/* ========================================================================= */

/*
	
*/
void init()
{
	display_control(DCM_SCR1|DCM_SCR2|DCM_SPR);
    text_screen_init();
	font_set_color(0x0c);	/* ] */
	text_put_string(0, 0, "MiniMemo      [}][`] Page 01");
	font_set_color(0x03);	/* ʏ */

	comm_start(COMM_SPEED_38400);
}

/*
	I
*/
void clean_up()
{
	comm_stop();
}

/*
	XL[͏
*/
void ws_key_hit(int ws_key)
{
	if(unfix_len == 0)
	{
		if(ws_key & KEY_X1)
		{
			cur_up();
		}
		else
		if(ws_key & KEY_X2)
		{
			cur_right();
		}
		else
		if(ws_key & KEY_X3)
		{
			cur_down();
		}
		else
		if(ws_key & KEY_X4)
		{
			cur_left();
		}
		else
		if(ws_key & KEY_Y2)
		{
			menu();
		}
		else
		if(ws_key & KEY_Y3)
		{
			mode_change();
		}
		else
		if(ws_key & KEY_A)
		{
			if(cur_page < 9)
			{
				disp_page(cur_page + 1);
			}
		}
		else
		if(ws_key & KEY_B)
		{
			if(cur_page > 0)
			{
				disp_page(cur_page - 1);
			}
		}
	}

	if(ws_key & KEY_Y1)
	{
		insert_change();
	}

	if(ws_key & KEY_Y4)
	{
		if(unfix_len == 0)
		{
			delete_char();
		}
		else
		{
			hide_unfix();
			unfix_len--;
			if(unfix_len > 0)
			{
				disp_unfix();
			}
			else
			{
				show_cursor();
			}
		}
	}
}

/*
	C
*/
void main(int argc, char *argv[])
{
	int		ws_key, ex_key, sel;
	BOOL	done = FALSE;

	/*
		
	*/
	init();

	/*
		t@Cǂݍ
	*/
	if(!read_memo())
	{
		text_put_string(5,  7, "");
		text_put_string(5,  8, "@t@C쐬ł܂@");
		text_put_string(5,  9, "");
		key_wait();
		goto exit_main;
	}
	disp_page(0);

	/*
		C[v
	*/
	while(!done)
	{
		/*
			X̃L[͏
		*/
		ws_key = key_hit_check_with_repeat();
		if(ws_key)
		{
			if(ws_key & KEY_START)
			{
				/*
					Ij[\
				*/
				sel = menu_select(exit_menu, 9, 6, sizeof(exit_menu) / 2);
				if(sel == -1)
				{
					continue;
				}
				else
				if(sel == EXIT_SAVE)
				{
					/*
						t@Cۑ
					*/
					write_memo();
				}
				done = TRUE;
				continue;
			}
			ws_key_hit(ws_key);
		}

		/*
			HandyKeỹL[͏
		*/
		if(rx_len() > 0)
		{
			ex_key = rx_getchar();
			ex_key_hit(ex_key);
		}

		/*
			J[\_
		*/
		blink_cursor();
	}

exit_main:
	/*
		I
	*/
	clean_up();
}
